diff --git a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index e43f9ee96..1f97baf51 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -500,7 +500,7 @@ public class BiomeFinder implements MinecraftAccessor {
 		} else {
 			SaveFormatBase saveFormat = new SaveFormat19134(worldFolder.getParentFile());
 			LevelStorage levelStorage = saveFormat.getLevelStorage(worldFolder.getName(), false);
-			world = new World(levelStorage, levelStorage.getLevelData().getWorldName(), levelStorage.getLevelData().getRandomSeed(), Dimension.OVERWORLD);
+			world = new World(levelStorage, Dimension.OVERWORLD);
 			biomeProvider = worldType.createBiomeProvider(world);
 		}
 		allBiomes.clear();
@@ -667,8 +667,8 @@ public class BiomeFinder implements MinecraftAccessor {
 	}
 
 	private static final class World extends net.minecraft.core.world.World {
-		public World(final @NotNull LevelStorage levelStorage, final @Nullable String name, final long seed, final @NotNull Dimension dimension) {
-			super(levelStorage, name, seed, dimension, null);
+		public World(final @NotNull LevelStorage levelStorage, final @NotNull Dimension dimension) {
+			super(levelStorage, null, dimension);
 		}
 
 		@Override
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 3813b09d7..f5ac77198 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -95,9 +95,6 @@ import net.minecraft.client.util.helper.Textures;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.client.world.WorldClientMP;
-import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
-import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
-import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
 import net.minecraft.client.world.save.LevelStorageClientSP;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
@@ -172,7 +169,6 @@ import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.PortalHandler;
-import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -189,7 +185,6 @@ import net.minecraft.core.world.save.SaveFormatBase;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
 import net.minecraft.core.world.settings.WorldConfiguration;
-import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Matrix4f;
@@ -2039,21 +2034,18 @@ public class Minecraft
     public void createAndStartWorld(final @NotNull WorldConfiguration worldConfiguration) {
         final @NotNull LevelStorage levelStorage = this.saveFormat.getLevelStorage(worldConfiguration.getFolderName(this.saveFormat), false);
         for (final @NotNull Dimension dimension : Dimension.getDimensionList().values()) {
-            final @Nullable WorldType worldType = worldConfiguration.getWorldTypeGroup().get(dimension);
-            final @NotNull DimensionData data = new DimensionData(worldType);
+            final @NotNull DimensionData data = new DimensionData(dimension, worldConfiguration);
             levelStorage.saveDimensionData(dimension.id, data);
         }
 
         final @NotNull WorldClient world = new WorldClient(
             this,
             levelStorage,
-            worldConfiguration.getFinalWorldName(),
-            worldConfiguration.getFinalNumericSeed(),
-            Dimension.OVERWORLD,
-            worldConfiguration.getStartingBiome()
+            worldConfiguration,
+            Dimension.OVERWORLD
         );
         world.getLevelData().setCheatsEnabled(worldConfiguration.getCheatsEnabled());
-        world.getLevelData().getGameRules().setValues(worldConfiguration.getGameRuleCollection());
+        world.getLevelData().getGameRules().setValues(worldConfiguration.getGameRules());
         world.getSpawnerConfig().set(worldConfiguration.getSpawnerConfig());
 
         this.statsCounter.add(StatList.createWorldStat, 1);
@@ -2095,7 +2087,7 @@ public class Minecraft
                 dimension = Dimension.OVERWORLD;
             }
 
-            WorldClient world = new WorldClient(this, saveHandler, null, 0L, dimension, null);
+            WorldClient world = new WorldClient(this, saveHandler, null, dimension);
             this.statsCounter.add(StatList.loadWorldStat, 1);
             this.statsCounter.add(StatList.startGameStat, 1);
             changeWorld(world, i18n.translateKey("gui.loading.label.loading"));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/PageComponent.java b/game/client/src/main/java/net/minecraft/client/gui/paged/PageComponent.java
index 8301b293e..b44e73e66 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/PageComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/PageComponent.java
@@ -1,23 +1,26 @@
 package net.minecraft.client.gui.paged;
 
 import net.minecraft.client.Minecraft;
+import org.jetbrains.annotations.NotNull;
 
 public interface PageComponent {
-    default void init(Minecraft mc) { }
+    default void init(final @NotNull Minecraft mc) { }
 
     int getHeight();
 
-    void render(int x, int y, int width, int relativeMouseX, int relativeMouseY);
+    void render(@NotNull ScreenPaged screen, int x, int y, int width, int relativeMouseX, int relativeMouseY);
 
     default void tick() { }
 
-    void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY);
+    boolean onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY);
 
-    void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY);
+    boolean onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY);
 
-    void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY);
+    boolean onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY);
 
     void onKeyPress(int keyCode, char character);
 
+    default void onClose() { }
+
     boolean matchesSearchTerm(String term);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
index f68d4b21a..84a2c8a2f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
@@ -16,8 +16,7 @@ import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 
-public class ScreenPaged
-    extends Screen {
+public class ScreenPaged extends Screen {
     protected static final int TOP_SPACING = 24;
     protected static final int BUTTON_SPACING = 4;
     protected static final int SEPARATOR_WIDTH = 8;
@@ -105,10 +104,18 @@ public class ScreenPaged
         }
     }
 
+    public int top() {
+        return this.top;
+    }
+
+    public int bottom() {
+        return this.bottom;
+    }
+
     private void drawPageItems(final int x, final int y, final int width, final int mouseX, final int mouseY) {
         int y2 = y;
         for (final @NotNull PageComponent component : this.selectedPage.getComponents()) {
-            component.render(x, y2, width, mouseX - x, mouseY - y2);
+            component.render(this, x, y2, width, mouseX - x, mouseY - y2);
             y2 += component.getHeight();
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
index 946de0f74..9b03df285 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
@@ -28,7 +28,7 @@ public class PopupBuilder {
         this.width = width;
     }
 
-    public PopupScreen build() {
+    public @NotNull PopupScreen build() {
         final PopupScreen popup = new PopupScreen(
             this.parent,
             this.width,
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
index d2ef59c6b..47dc33f90 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.server;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.client.gui.paged.ScreenPaged;
 import net.minecraft.client.render.font.Alignment;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
@@ -27,7 +28,7 @@ public class ServerEntryComponent implements PageComponent {
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    public void render(final @NotNull ScreenPaged screen, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         TessellatorGeneral t = GLRenderer.getTessellator();
         if (this.entry.icon != null) {
             this.entry.icon.bind();
@@ -70,18 +71,19 @@ public class ServerEntryComponent implements PageComponent {
     }
 
     @Override
-    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    public boolean onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         this.attachedScreen.setSelectedEntry(this.entry);
+        return true;
     }
 
     @Override
-    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-
+    public boolean onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        return false;
     }
 
     @Override
-    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-
+    public boolean onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        return false;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java b/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
index e3134975e..d578b2d40 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.server;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.client.gui.paged.ScreenPaged;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.ServerAddress;
 import org.jetbrains.annotations.NotNull;
@@ -23,7 +24,7 @@ public class SeverDirectConnectComponent implements PageComponent {
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    public void render(final @NotNull ScreenPaged screen, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         int _x = x + width / 2 - this.ipField.width / 2;
         int _y = this.attachedScreen.height / 2 - 40;
 
@@ -45,21 +46,24 @@ public class SeverDirectConnectComponent implements PageComponent {
     }
 
     @Override
-    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    public boolean onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         this.ipField.mouseClicked(x + relativeMouseX, y + relativeMouseY, 0);
         if (this.connectButton.isHovered(x + relativeMouseX, y + relativeMouseY)) {
             connect();
+            return true;
         }
+
+        return false;
     }
 
     @Override
-    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-
+    public boolean onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        return false;
     }
 
     @Override
-    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-
+    public boolean onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        return false;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
index fd96114d7..9280c2c5a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.worldsettings;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.client.gui.paged.ScreenPaged;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
@@ -42,7 +43,7 @@ public abstract class ButtonComponent
     }
 
     @Override
-    public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+    public void render(final @NotNull ScreenPaged screen, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
         final @NotNull String translated = I18n.getInstance().translateKey(this.translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= this.getHeight() - COMPONENT_SPACING) {
@@ -59,24 +60,30 @@ public abstract class ButtonComponent
     }
 
     @Override
-    public void onMouseClick(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+    public boolean onMouseClick(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
         if (relativeMouseX >= width - BUTTON_WIDTH && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
             this.buttonClicked(mouseButton, x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+            return true;
         } else if (this.resetButton.enabled && relativeMouseX >= width - BUTTON_WIDTH - 20 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
             this.resetValue();
+            return true;
         }
+
+        return false;
     }
 
     @Override
-    public void onMouseMove(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+    public boolean onMouseMove(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
         this.buttonDragged(x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+        return true;
     }
 
     @Override
-    public void onMouseRelease(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+    public boolean onMouseRelease(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
         this.buttonReleased(mouseButton, x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+        return true;
     }
 
     protected abstract void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/CategoryMobSpawningComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/CategoryMobSpawningComponent.java
index b610bd657..a7c11b3c8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/CategoryMobSpawningComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/CategoryMobSpawningComponent.java
@@ -33,7 +33,7 @@ public class CategoryMobSpawningComponent extends ButtonComponent {
     }
 
     @Override
-    public void init(Minecraft mc) {
+    public void init(@NotNull Minecraft mc) {
         onChange();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/EntryMobSpawningComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/EntryMobSpawningComponent.java
index 4116250e8..895310b6a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/EntryMobSpawningComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/EntryMobSpawningComponent.java
@@ -36,7 +36,7 @@ public class EntryMobSpawningComponent extends ButtonComponent{
     }
 
     @Override
-    public void init(Minecraft mc) {
+    public void init(@NotNull Minecraft mc) {
         onChange();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/NodeComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/NodeComponent.java
new file mode 100644
index 000000000..84620aee4
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/NodeComponent.java
@@ -0,0 +1,17 @@
+package net.minecraft.client.gui.worldsettings;
+
+import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.settings.SettingNode;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import org.jetbrains.annotations.NotNull;
+
+public interface NodeComponent extends PageComponent {
+    void onUpdate(final @NotNull Dimension dimension, final @NotNull WorldConfiguration worldConfiguration);
+
+    @NotNull SettingNode getNode();
+
+    int getNestLevel();
+
+    void reset();
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
index 3baacf81f..d138d87a7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
@@ -1,27 +1,54 @@
 package net.minecraft.client.gui.worldsettings;
 
+import it.unimi.dsi.fastutil.objects.Object2ObjectArrayMap;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.paged.Page;
 import net.minecraft.client.gui.paged.PageComponent;
 import net.minecraft.client.gui.paged.PageRegistry;
 import net.minecraft.client.gui.paged.ScreenPaged;
+import net.minecraft.client.gui.worldsettings.gamerule.BooleanGameRuleComponent;
+import net.minecraft.client.gui.worldsettings.settingnode.CategoryComponent;
+import net.minecraft.client.gui.worldsettings.settingnode.NestedNodeComponent;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRuleBoolean;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.lang.text.TranslatableText;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.settings.WorldSettingNodes;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
+import java.util.Map;
+import java.util.Objects;
 
-public class ScreenWorldSettings
-    extends ScreenPaged {
-    public static final @NotNull PageRegistry CREATE_WORLD_PAGES = new PageRegistry();
-    public static final @NotNull Page PAGE_GAME_RULES = CREATE_WORLD_PAGES.register(new Page("gui.world_settings.page.game_rules.title", Items.PAPER.getDefaultStack()));
+public class ScreenWorldSettings extends ScreenPaged implements WorldConfiguration.ChangeListener {
+    public static final @NotNull PageRegistry WORLD_SETTINGS_PAGES = new PageRegistry();
+    private static final @NotNull Map<@NotNull Dimension, @NotNull NodeComponent> WORLD_SETTINGS_ROOT_COMPONENTS = new Object2ObjectArrayMap<>();
+    static {
+        for (final @NotNull Dimension dimension : Dimension.getDimensionList().values()) {
+            WORLD_SETTINGS_ROOT_COMPONENTS.put(dimension, new NestedNodeComponent(WorldSettingNodes.getRootNode(), 0));
+        }
+    }
+
+    public static final @NotNull Page PAGE_WORLD_SETTINGS = WORLD_SETTINGS_PAGES.register(
+        new Page("gui.world_settings.page.world_settings.title", Items.PAINTBRUSH.getDefaultStack())
+            .withComponent(new WorldTypeButtonComponent("gui.world_settings.label.world_type", null))
+            .withComponent(
+                new CategoryComponent(new TranslatableText("gui.world_settings.page.world_settings.category.overworld"))
+                    .withComponent(WORLD_SETTINGS_ROOT_COMPONENTS.get(Dimension.OVERWORLD))
+            )
+            .withComponent(
+                new CategoryComponent(new TranslatableText("gui.world_settings.page.world_settings.category.nether"))
+                    .withComponent(WORLD_SETTINGS_ROOT_COMPONENTS.get(Dimension.NETHER))
+            )
+    );
 
+    public static final @NotNull Page PAGE_GAME_RULES = WORLD_SETTINGS_PAGES.register(new Page("gui.world_settings.page.game_rules.title", Items.PAPER.getDefaultStack()));
     static {
         for (final @NotNull GameRule<?> gameRule : Registries.GAME_RULES) {
             if (gameRule instanceof GameRuleBoolean) {
@@ -30,17 +57,11 @@ public class ScreenWorldSettings
         }
     }
 
-    public static final @NotNull Page PAGE_WORLD_SETTINGS = CREATE_WORLD_PAGES.register(
-        new Page("gui.world_settings.page.world_settings.title", Items.PAINTBRUSH.getDefaultStack())
-            .withComponent(new WorldTypeButtonComponent("gui.world_settings.label.world_type", null))
-            .withComponent(new StartingBiomeButtonComponent("gui.world_settings.label.starting_biome", null))
-    );
-    public static final @NotNull Page PAGE_MOB_SPAWNING = CREATE_WORLD_PAGES.register(
+    public static final @NotNull Page PAGE_MOB_SPAWNING = WORLD_SETTINGS_PAGES.register(
         new Page("gui.world_settings.page.mob_spawning.title", Items.EGG_CHICKEN.getDefaultStack())
             .withComponent(new CategoryMobSpawningComponent(CategoryMobSpawningComponent.Type.HOSTILE))
             .withComponent(new CategoryMobSpawningComponent(CategoryMobSpawningComponent.Type.PASSIVE))
     );
-
     static {
         for (var entry : EntityDispatcher.getInstance().entries) {
             if (Mob.class.isAssignableFrom(entry.entityClass) && entry.nameKey != null) { // Probably have something better than checking if name key is null
@@ -52,23 +73,25 @@ public class ScreenWorldSettings
     private final @NotNull WorldConfiguration worldConfiguration;
 
     public ScreenWorldSettings(final @Nullable Screen parent, final @NotNull WorldConfiguration worldConfiguration) {
-        super(parent, CREATE_WORLD_PAGES, PAGE_GAME_RULES, "gui.world_settings.label.title", new String[]{"gui.world_settings.button.done"});
+        super(parent, WORLD_SETTINGS_PAGES, PAGE_WORLD_SETTINGS, "gui.world_settings.label.title", new String[]{"gui.world_settings.button.done"});
 
         this.worldConfiguration = worldConfiguration;
-
-        final List<PageComponent> gameRulesPageComponents = PAGE_GAME_RULES.getComponents();
-        for (final @NotNull PageComponent component : gameRulesPageComponents) {
-            if (component instanceof BooleanGameRuleComponent ruleComponent) {
-                ruleComponent.setGameRuleCollection(worldConfiguration.getGameRuleCollection());
-            }
+        this.worldConfiguration.setChangeListener(this);
+        for (final @NotNull Dimension dimension : WORLD_SETTINGS_ROOT_COMPONENTS.keySet()) {
+            Objects.requireNonNull(WORLD_SETTINGS_ROOT_COMPONENTS.get(dimension)).onUpdate(dimension, worldConfiguration);
         }
 
         final List<PageComponent> worldSettingsPageComponents = PAGE_WORLD_SETTINGS.getComponents();
         for (final @NotNull PageComponent component : worldSettingsPageComponents) {
             if (component instanceof WorldTypeButtonComponent typeButtonComponent) {
                 typeButtonComponent.setWorldConfiguration(worldConfiguration);
-            } else if (component instanceof StartingBiomeButtonComponent startingBiomeButtonComponent) {
-                startingBiomeButtonComponent.setWorldConfiguration(worldConfiguration);
+            }
+        }
+
+        final List<PageComponent> gameRulesPageComponents = PAGE_GAME_RULES.getComponents();
+        for (final @NotNull PageComponent component : gameRulesPageComponents) {
+            if (component instanceof BooleanGameRuleComponent ruleComponent) {
+                ruleComponent.setGameRuleCollection(worldConfiguration.getGameRules());
             }
         }
 
@@ -81,4 +104,11 @@ public class ScreenWorldSettings
             }
         }
     }
+
+    @Override
+    public void onChanged() {
+        for (final @NotNull Dimension dimension : WORLD_SETTINGS_ROOT_COMPONENTS.keySet()) {
+            Objects.requireNonNull(WORLD_SETTINGS_ROOT_COMPONENTS.get(dimension)).onUpdate(dimension, worldConfiguration);
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/BooleanGameRuleComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/gamerule/BooleanGameRuleComponent.java
similarity index 96%
rename from game/client/src/main/java/net/minecraft/client/gui/worldsettings/BooleanGameRuleComponent.java
rename to game/client/src/main/java/net/minecraft/client/gui/worldsettings/gamerule/BooleanGameRuleComponent.java
index fcb5c878b..bd9a18a4d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/BooleanGameRuleComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/gamerule/BooleanGameRuleComponent.java
@@ -1,7 +1,8 @@
-package net.minecraft.client.gui.worldsettings;
+package net.minecraft.client.gui.worldsettings.gamerule;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.SwitchElement;
+import net.minecraft.client.gui.worldsettings.ButtonComponent;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.data.gamerule.GameRuleBoolean;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/IntegerGameRuleComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/gamerule/IntegerGameRuleComponent.java
similarity index 94%
rename from game/client/src/main/java/net/minecraft/client/gui/worldsettings/IntegerGameRuleComponent.java
rename to game/client/src/main/java/net/minecraft/client/gui/worldsettings/gamerule/IntegerGameRuleComponent.java
index 153aae41b..6cbb3a6bc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/IntegerGameRuleComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/gamerule/IntegerGameRuleComponent.java
@@ -1,7 +1,8 @@
-package net.minecraft.client.gui.worldsettings;
+package net.minecraft.client.gui.worldsettings.gamerule;
 
 import net.minecraft.client.gui.SwitchElement;
 import net.minecraft.client.gui.TextFieldElement;
+import net.minecraft.client.gui.worldsettings.ButtonComponent;
 import net.minecraft.core.data.gamerule.GameRuleBoolean;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
 import net.minecraft.core.data.gamerule.GameRuleInteger;
